//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "MainAppUnit.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "BPLBase"
#pragma link "BPLServer"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
  : TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TForm1::exit1Click(TObject *Sender)
{
  Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormCreate(TObject *Sender)
{
  DynBPLServer1->IniFileName =
    ChangeFileExt(Application->ExeName, ".ini" );
  DynBPLServer1->LoadFromIniFile();
  DynBPLServer1->CallService("App.Start",NULL,true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::FormDestroy(TObject *Sender)
{
  for( int i=0; i<FormsMenu->Count; i++ )
  {
    if( FormsMenu->Items[i]->Tag != 0 )
    {
      ((TForm *) FormsMenu->Items[i]->Tag)->Visible = false;
      ((TForm *) FormsMenu->Items[i]->Tag)->Parent = NULL;
    }
  }

  DynBPLServer1->CallService("App.End",NULL,true);
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Configure1Click(TObject *Sender)
{
  DynBPLServer1->ConfigDialog();
  DynBPLServer1->SaveToIniFile();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::DynBPLServer1ServiceCall(TObject *Sender,
      AnsiString ServiceText, int ServiceNumber, TObject *Subject,
      bool handled)
{
  switch( ServiceNumber )
  {
    case 0: // Add.Form
      if( Subject->InheritsFrom(__classid(TForm) ) )
        AddForm( (TDynBPLBase *) Sender, (TForm *) Subject );
      break;
    case 1: // Add.Menu
      if( Subject->InheritsFrom(__classid(TPopupMenu) ) )
      {
        TPopupMenu *menu = (TPopupMenu *) Subject;
        ModulesMenu->Add(menu->Items);
        menu->Items->Caption = ((TDynBPLBase*)Sender)->Caption;
      }
      break;
    case 2: // Say.*
      ShowMessage( &ServiceText[5] );
      break;
  }

}
//---------------------------------------------------------------------------


void __fastcall TForm1::AddForm(TDynBPLBase * Client, TForm * ClientForm)
{
  ClientForm->Parent = Panel1;
  ClientForm->Visible = false;
  ClientForm->Align = alClient;
  ClientForm->BorderStyle = bsNone;
  ClientForm->BorderIcons = TBorderIcons() ;
  ClientForm->TabStop = true;
  ClientForm->TabOrder = 0;

  TMenuItem *mItem = new TMenuItem(Client);
  mItem->Caption = ClientForm->Caption;
  mItem->Tag = (int)ClientForm;
  mItem->OnClick = FormMenuClick;
  if( !ClientForm->Icon->Empty )
    mItem->ImageIndex = ImageList1->AddIcon(ClientForm->Icon);

  FormsMenu->Add(mItem);
  FreeNotification(ClientForm);
}

void __fastcall TForm1::FormMenuClick(TObject *Sender)
{
  TMenuItem *mItem = (TMenuItem *) Sender;
  if( mItem->Checked )
    return;

  for( int i=0; i<FormsMenu->Count; i++ )
  {
    FormsMenu->Items[i]->Checked = false;
    if( FormsMenu->Items[i]->Tag != 0 )
      ((TForm *) FormsMenu->Items[i]->Tag)->Visible = false;
  }

  mItem->Checked = true;
  if( mItem->Tag != 0 )
    ((TForm *) mItem->Tag)->Visible = true;
}
//---------------------------------------------------------------------------

void __fastcall TForm1::ReportNumberofIcons1Click(TObject *Sender)
{
  ShowMessage( IntToStr(ImageList1->Count) + " Icons" );
}
//---------------------------------------------------------------------------


void __fastcall TForm1::Notification(TComponent * AComponent, TOperation Operation)
{
  TForm::Notification( AComponent,  Operation);
  if( AComponent == this
  ||  AComponent->Owner == this
  ||  Operation != opRemove
  ||  ComponentState.Contains(csDestroying) )
    return;

  TMenuItem *mItem;
  for( int i=0; i<FormsMenu->Count; i++ )
  {
    mItem = FormsMenu->Items[i];
    if( mItem->Tag == (int) AComponent )
    {
      if( mItem->ImageIndex >= 0 )
        ImageList1->Delete(mItem->ImageIndex);
      mItem->ImageIndex = -1;
      for(int j=i+1; j<FormsMenu->Count; j++ )
        if( FormsMenu->Items[j]->ImageIndex > mItem->ImageIndex )
          FormsMenu->Items[j]->ImageIndex--;
    }
  }

}
